import { Injectable } from '@nestjs/common';
import * as dns from 'dns';
import * as util from 'util';

@Injectable()
export class DnsService {
  private lookup = util.promisify(dns.lookup);

  async isValidUrl(url: string): Promise<boolean> {
    try {
      const hostname = new URL(url).hostname;
      await this.lookup(hostname);
      return true;
    } catch {
      return false;
    }
  }
}